

Imports System.Runtime.InteropServices

Partial Public Class InputDevice

    Private Delegate Sub MidiInProc(ByVal handle As Integer, ByVal msg As Integer, ByVal instance As Integer, ByVal param1 As Integer, ByVal param2 As Integer)

    <DllImport("winmm.dll")> _
    Private Shared Function midiInOpen(ByRef handle As Integer, ByVal deviceID As Integer, ByVal proc As MidiInProc, ByVal instance As Integer, ByVal flags As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInClose(ByVal handle As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInStart(ByVal handle As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInStop(ByVal handle As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInReset(ByVal handle As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInPrepareHeader(ByVal handle As Integer, ByVal headerPtr As IntPtr, ByVal sizeOfMidiHeader As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInUnprepareHeader(ByVal handle As Integer, ByVal headerPtr As IntPtr, ByVal sizeOfMidiHeader As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInAddBuffer(ByVal handle As Integer, ByVal headerPtr As IntPtr, ByVal sizeOfMidiHeader As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInGetDevCaps(ByVal deviceID As Integer, ByRef caps As MidiInCaps, ByVal sizeOfMidiInCaps As Integer) As Integer
    End Function

    <DllImport("winmm.dll")> _
    Private Shared Function midiInGetNumDevs() As Integer
    End Function

    Private Const MIDI_IO_STATUS As Integer = &H20

    Private Const MIM_OPEN As Integer = &H3C1
    Private Const MIM_CLOSE As Integer = &H3C2
    Private Const MIM_DATA As Integer = &H3C3
    Private Const MIM_LONGDATA As Integer = &H3C4
    Private Const MIM_ERROR As Integer = &H3C5
    Private Const MIM_LONGERROR As Integer = &H3C6
    Private Const MIM_MOREDATA As Integer = &H3CC
    Private Const MHDR_DONE As Integer = &H1

End Class
