

Imports System.Runtime.InteropServices

<StructLayout(LayoutKind.Sequential)> _
Friend Structure MidiHeader

    Public data As IntPtr

    Public bufferLength As Integer

    ' ------------------------------------------ amount of data in the buffer
    '                                            should be less than or equal to the dwBufferLength
    Public bytesRecorded As Integer

    Public user As Integer

    Public flags As Integer

    ' ------------------------------------------- reserved - do not use
    Public [next] As IntPtr

    ' ------------------------------------------- reserved - do not use
    Public reserved As Integer

    ' ------------------------------------------- offset into the buffer when a callback is performed
    '                                             ( this callback is generated because the MEVT_F_CALLBACK flag 
    '                                               is set in the dwEvent member of the MidiEventArgs structure ) 
    '                                             This offset enables to determine which event caused the callback 
    Public offset As Integer

    ' ------------------------------------------- reserved - do not use
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    Public reservedArray As Integer()

End Structure
