

Public Enum MessageType
	Channel
	SystemExclusive
	SystemCommon
	SystemRealtime
	Meta
End Enum

' -------------------------------------------------------------- basic functionality for all MIDI messages
Public Interface IMidiMessage

    ' --------------------------------------------- Gets a byte array representation of the MIDI message.
    Function GetBytes() As Byte()

    ' --------------------------------------------- Gets the MIDI message's status value.
    ReadOnly Property Status() As Integer

    ' --------------------------------------------- Gets the MIDI event's type.
    ReadOnly Property MessageType() As MessageType

End Interface
